; haiku (c) Gasman 2005
; tile.asm: tiled background

tile
			ld hl,tilebmp
			ld b,32
tilesine
			ld de,sine
mktile
			push hl
			xor a
			ld (hl),a
			inc l
			ld (hl),a
			inc l
			ld (hl),a
			inc l
			ld (hl),a
			pop hl
			ld a,e
			add a,4
			ld e,a

			ld a,(de)
			and 0x1f
			ld c,a
			srl a
			srl a
			srl a
			push hl
			add a,l
			ld l,a
			ld a,c
			and 0x07
			push de
			ld e,a
			ld d,screenbits2 / 0x100
			ld a,(de)
			ld (hl),a
			pop de
			pop hl

			ld a,4
			add a,l
			ld l,a
			
			djnz mktile
			ld a,(tilesine + 1)
			inc a
			ld (tilesine + 1),a
			
			halt
			ld (tile_spback + 1),sp
			
			ld hl,tilebmp
			exx
			
			ld hl,ylo

			ld b,192
tile_line
			ld a,(hl)
			add a,0x1a
			ld e,a
			inc h
			ld d,(hl)
			dec h
			inc l
			ld (tile_sp + 1),de
			exx
			ld c,(hl)
			inc l
			ld b,(hl)
			inc l
			ld e,(hl)
			inc l
			ld d,(hl)
			inc l
			res 7,l
			
tile_sp		ld sp,0
		rept 6
			push de
			push bc
		endm
			exx
			djnz tile_line
			
tile_spback	ld sp,0
			ret

tilebmp 	equ 0xc300